
#define MAX_BUFFER_LENGTH	15000  // maximal number of characters per line
#define MAX_NUM_SEQ             23000  // maximal number of sequences
#define MAX_SEQ_LENGTH          15001  // maximal length of any sequence in input data
#define MAX_SEQ_HEADER          40
#define MAX_SITES               80000  // maximal number of sites in the entire data per motif
#define MAX_PWM_LENGTH          120    // maximal pwm/motif length
#define MAX_DIMENSION           50000  // maximal pwm score dimension
#define Z_CUTOFF                6.0    // z-score cutoff for top-ranked k-mers
#define PSEUDO_COUNT	        0.01   // pseudo count
#define DOUBLE_TO_INT_SCALE	200.0  // (int)PWM=(int)(PWM*DOUBLE_TO_INT_SCALE)
#define MIN_BITS1		0.4    // bits cutoff for extending/trimming motif
#define MIN_BITS2		0.5    // out of 2bits
#define MIN_BITS3		0.6    // out of 2bits
#define BASE_EXT		10     // # of bases extended at each side of a motif
#define FLANKING_BASES		10     // output motifs with 'BASE_EXT' bases on each side
#define DUMMY_FITNESS		99999  // dummy fitness score for motifs that do not meet minimal requirements
#define NUM_NO_MOTIF            1      // GADEM stops when the number of GADEM cycles produces no motifs
#define SIMILARITY_ALPHA        0.35   // goodness-of-fit alpha level
#define PWM_CONVERGENCE         0.0005 // EM convergence
//#define MAJOR                   0.5  // MEME's 
//#define MINOR                   0.1666666666 // MEME's
#define MAJOR                   1.0
#define MINOR                   0.0

#define MAXP_MUTATION_RATE	0.5
#define MAXP_BASE		0.2
#define MAXP_FACTOR		0.2
#define MAXP_SCALE		5  // maxpfactor =MAXP_BASE+MAXP_FACTOR*((int)(MAXP_SCALE*genrand()));
                                   //            =0.2 + .2*0 = 0.2
                                   //            =0.2 + .2*1 = 0.4
                                   //            =0.2 + .2*2 = 0.6
                                   //            =0.2 + .2*3 = 0.8
                                   //            =0.2 + .2*4 = 1.0
                                   // maxp=maxpfactor*numSeq
                                   // estimated number of binding sites for computing P(Yij=1|PWM,Seq),
                                   // the probability of site start at position j on seq i (see GADEM suppl. text)

#define min(a,b)                (((a)<(b))?(a):(b))
#define max(a,b)                (((a)>(b))?(a):(b))
#define mod(a,b)		((a)-(b)*((a)/(b)))

